import pathlib
import sys
import os

current_file = pathlib.Path(__file__).resolve()
project_root = current_file.parent

project_dir_name = 'cls_train'
while project_root.name != project_dir_name and project_root != project_root.parent:
    project_root = project_root.parent

if project_root.name != project_dir_name:
    raise Exception(f"没有找到项目路径: {project_dir_name}")
sys.path.append(str(project_root))

import argparse
import os
import sys
from pathlib import Path

from loguru import logger  # 导入 loguru

def get_logger(log_file, rotation="500 MB", compression="zip", enqueue=True):

    log_format = "{time:YYYY-MM-DD HH:mm:ss.SSS} | {level: <4} | [{module}].[{function}]:{line} - {message}"    
    logger.remove()
    logger.add(log_file, format=log_format, rotation=rotation, compression=compression, enqueue=enqueue)
    return logger


